﻿Type=Class
Version=4.01
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
#if B4j
	Private fx As JFX
#end if
	
#if B4a
	Dim mAct As Activity
#end if
	
	Dim jfPlayer As jFuguePlayer
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	jfPlayer.Initialize
End Sub

#if B4j
Sub Setup(mForm As Form)
	mForm.RootPane.LoadLayout("1") 'Load the layout file.
End Sub

Sub RunExample_Action
	Dim B As Button = Sender
	CallSub("","Example" & B.Tag)
End Sub

#end If

#if B4a
Sub Setup(Act As Activity)
	mAct = Act
	mAct.LoadLayout("1")
End Sub

Sub RunExample_Click
	Dim B As Button = Sender
	CallSub(Me,"Example" & B.Tag)
End Sub
#end if

'
'"Hello, World" in JFugue
'
Sub Example1
	
	jfPlayer.Play("C D E F G A B")
	
End Sub

'
'Playing multiple voices, multiple instruments, rests, chords, and durations
'
Sub Example2

	jfPlayer.Play("V0 I[Piano] Eq Ch. | Eq Ch. | Dq Eq Dq Cq   V1 I[Flute] Rw | Rw | GmajQQQ CmajQ")
End Sub

'
'Introduction to Patterns
'
Sub Example3
	
	'String variables that mimic the required imports
	Dim PatternClassName As String = "org.jfugue.pattern.Pattern"
	
	'Create and initialize our wrappers for the pattern class objects
	Dim p1,p2 As JavaObject
	
	'Create the actual java objects for the pattern class objects, with 1 parameter
	p1.InitializeNewInstance(PatternClassName,Array("V0 I[Piano] Eq Ch. | Eq Ch. | Dq Eq Dq Cq"))
	p2.InitializeNewInstance(PatternClassName,Array("V1 I[Flute] Rw     | Rw     | GmajQQQ  CmajQ"))
	
	
	'We are using a single parameter call, but the underlying java method can take an array to play more than one
	'pattern at a time.  These are unwrapped from our Wrapper objects in the JOWrapper class.  In this case the array must be of type JOWrapper
	
	jfPlayer.Play(Array(p1,p2))
	
	
End Sub

'
'Introduction to Patterns, Part 2
'
Sub Example4
	
	'String variables that mimic the required imports
	Dim PatternClassName As String = "org.jfugue.pattern.Pattern"
	
	'Create and initialize our wrappers for the pattern class objects
	Dim p1,p2 As JavaObject
	
	'Create the actual java objects for the pattern class objects, with 1 parameter and chain further calls
	p1.InitializeNewInstance(PatternClassName,Array("Eq Ch. | Eq Ch. | Dq Eq Dq Cq")).runMethodJO("setVoice",Array(0)).RunMethod("setInstrument",Array("Piano"))
	p2.InitializeNewInstance(PatternClassName,Array("Rw     | Rw     | GmajQQQ  CmajQ")).RunMethodJO("setVoice",Array(1)).RunMethod("setInstrument",Array("Flute"))
	
	jfPlayer.play(Array(p1,p2))
	
End Sub

'
'Introduction to Chord Progressions
'
Sub Example5
	
	Dim ChordProgressionClassName As String = "org.jfugue.theory.ChordProgression"

	Dim cp As JavaObject
	cp.InitializeNewInstance(ChordProgressionClassName,Array("I IV V"))
	
	'Get the collection of chord objects from the chordprogression
	Dim Chords() As Object = cp.RunMethodJO("setKey",Array("C")).RunMethod("getChords",Null)
	
	'It is not always necessary to specifically set the type for a JavaObject (or JOWrapper) for objects that are returned as they will already be of the correct type
	'We just need to know what methods can be called on them (see the relevant documentation)
	For Each Chord As Object In Chords
		'But if the returned element is an array or collection, then we need to assign each one to a JavaObject (or JOWrapper) so we can accesss it's methods
		Dim CH As JavaObject = Chord
		Log("Chord " & Chord & " has these notes")
		Dim Notes() As Object = CH.RunMethod("getNotes",Null)
		For Each Note As Object In Notes
			Log(Note)
		Next
	Next
	
	jfPlayer.Play(cp)
	
End Sub

'
'Advanced Chord Progressions
'
Sub Example6
	
	Dim ChordProgressionClassName As String = "org.jfugue.theory.ChordProgression"
	
	Dim cp As JavaObject
	cp.InitializeNewInstance(ChordProgressionClassName,Array("I IV V"))
	

	jfPlayer.Play(cp.RunMethod("eachChordAs",Array("$0q $1q $2q Rq")))

	jfPlayer.Play(cp.RunMethodJO("allChordsAs",Array("$0q $0q $0q $0q $1q $1q $2q $0q")))

	jfPlayer.Play(cp.runmethodjo("allChordsAs",Array("$0 $0 $0 $0 $1 $1 $2 $0")).runmethod("eachChordAs",Array("V0 $0s $1s $2s Rs V1 $_q")))
	
	End Sub
'
'Twelve-Bar Blues in Two Lines of Code (Three in our case)
'
Sub Example7
	
	'String variables that mimic the required imports
	Dim ChordProgressionClassName As String = "org.jfugue.theory.ChordProgression"
	
	Dim cp As JavaObject
	Dim Pattern As JavaObject

	cp.InitializeNewInstance(ChordProgressionClassName,Array("I IV V")) _
	.RunMethodJO("distribute",Array("7%6")) _
	.RunMethodJO("allChordsAs",Array("$0 $0 $0 $0 $1 $1 $0 $0 $2 $1 $0 $0")) _
	.RunMethodJO("eachChordAs",Array("$0ia100 $1ia80 $2ia80 $3ia80 $4ia100 $3ia80 $2ia80 $1ia80"))
	Pattern = cp.RunMethodJO("getPattern",Null)
	Pattern.RunMethodJO("setInstrument",Array("Acoustic_Bass")).RunMethod("setTempo",Array(100))
	
	jfPlayer.Play(Pattern)

End Sub

'
'Introduction to Rhythms
'
Sub Example8
	'String variables that mimic the required imports
	Dim RhythmClassName As String = "org.jfugue.rhythm.Rhythm"
	
	Dim Rhythm As JavaObject
	Rhythm.InitializeNewInstance(RhythmClassName,Null).RunMethodJO("addLayer",Array("O..oO...O..oOO..")) _
        .RunMethodJO("addLayer",Array("..S...S...S...S.")) _
        .RunMethodJO("addLayer",Array("````````````````")) _
        .RunMethod("addLayer",Array("...............+"))
	
	jfPlayer.Play(Rhythm)

End Sub

'
'Advanced Rhythms
'
Sub Example9
	'
	'Note : Start timing seems much improved if you set a tempo on the Pattern  See Example 7
	'
	
	'String variables that mimic the required imports
	Dim RhythmClassName As String = "org.jfugue.rhythm.Rhythm"
	
	Dim Rhythm As JavaObject
	Dim Pattern As JavaObject
	
	Pattern = Rhythm.InitializeNewInstance(RhythmClassName,Null).RunMethodJO("addLayer",Array("O..oO...O..oOO..")) _
        .RunMethodJO("addLayer",Array("..S...S...S...S.")) _
        .RunMethodJO("addLayer",Array("````````````````")) _
        .RunMethodJO("addLayer",Array("...............+")) _
		.RunMethodJO("addOneTimeAltLayer",Array(3, 3, "...+...+...+...+")) _ ' Replace Layer 3 with this string on the 4th (count from 0) measure 
		.RunMethodJO("setLength",Array(4)) _
		.RunMethodJO("getPattern",Null)

	jfPlayer.Play(Pattern.RunMethod("repeat",Array(2)))
	
End Sub