﻿Type=Class
Version=4.01
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals

#Region B4j Globals
#if B4j
	Private fx As JFX
	Private Player,ManagedPlayer As JavaObject
	Private PlayerClassName As String = "org.jfugue.player.Player"
	
#end if
#End Region B4j Globals

#Region B4a Globals
#if B4a
	Dim MP As MediaPlayer
	Dim MidiFileManagerClassName As String = "org.jfugue.midi.MidiFileManager"
	Dim PatternClassName As String = "org.jfugue.pattern.Pattern"
	Dim FileDir As String = File.DirDefaultExternal
	Dim FileName As String = "test.mid"
	Dim Queue As List
#end if
#End Region B4a Globals
End Sub

#Region B4j Code
#if B4j
	'Initializes the object. You can add parameters to this method if needed.
	Sub Initialize
	InitPlayer
	End Sub
	
	Sub Play(Pattern As Object)
		InitPlayer

		Dim P1 As JavaObject

		'If an array has been passed, create an array of the correct type to pass to the player
		Dim Test As String = GetType(Pattern)
		If Test.StartsWith("[") And Pattern Is JavaObject Then
			Dim ObjArr() As Object = Pattern
			P1.InitializeArray(GetType(ObjArr(0)),Pattern)
		Else
			P1 = Pattern
		End If
		
		Player.RunMethod("play",Array(P1))
		Release
	End Sub

	Private Sub InitPlayer
		Player.InitializeNewInstance(PlayerClassName,Null)

		'Create the actual java objects for the pattern class objects, with no parameters
		Player.InitializeNewInstance(PlayerClassName,Null)
		ManagedPlayer = Player.RunMethodJO("getManagedPlayer",Null)
	End Sub

	Sub Stop
		Pause
		Dim ToStart As Long = 0
		ManagedPlayer.RunMethod("seek",Array(ToStart))
	End Sub
	Sub Pause
		ManagedPlayer.RunMethod("pause",Null)
	End Sub
	'Release the Player resources
	Sub Release
		ManagedPlayer.RunMethod("finish",Null)
	End Sub
	Sub Resume
		ManagedPlayer.RunMethod("resume",Null)
	End Sub

#end if
#End Region B4j Code

#Region B4a Code
#if B4a

	Public Sub Initialize
		MP.Initialize2("MP")
		Queue.Initialize
	End Sub

	Sub Play(Pattern As Object)

		If MP.IsPlaying Then
			Queue.add(Pattern)
			Return
		End If
		Dim P1 As JavaObject
		If Pattern Is String Then
			P1.InitializeNewInstance(PatternClassName,Array(Pattern))
		Else
			'If an array has been passed, create an array of the correct type to pass to the player
			Dim Test As String = GetType(Pattern)
			If Test.StartsWith("[") And Pattern Is JavaObject Then
				Dim ObjArr() As Object = Pattern
				Pattern = P1.InitializeArray(GetType(ObjArr(0)),Pattern)
			End If
			If GetType(Pattern).StartsWith("[") Then
				P1.InitializeNewInstance(PatternClassName,Null)
				P1.RunMethod("add",Array(Pattern))
			Else
				P1 = Pattern
			End If
		End If
		SaveFile(FileDir,FileName,P1)
		PlayFile(FileDir,FileName)
		
	End Sub
	'Stops the current pattern and clears the queue
	Sub Stop
		Queue.Clear
		MP.Stop
	End Sub
	'Skip to the next queued pattern (if there is one)
	Sub Skip
		MP.Stop
	End Sub

	'Release the Media Player resources
	Sub Release
		MP.Release
	End Sub

	Sub MP_Complete
		If Queue.Size > 0 Then
			Dim P As Object = Queue.Get(0)
			Queue.RemoveAt(0)
			Play(p)
		Else
			Log("Play Finished")
		End If
	End Sub

	Sub SaveFile(FD As String,FN As String, Source As JavaObject)
		Dim MidiFile As JavaObject
		
		Dim FileClassName As String = "java.io.File"
		MidiFile.InitializeNewInstance(FileClassName,Array(FD,FN))
		
		Dim MidiFileManager As JavaObject
		MidiFileManager.InitializeStatic(MidiFileManagerClassName)
		
		MidiFileManager.RunMethod("savePatternToMidi",Array(Source,MidiFile))
	End Sub

	Sub PlayFile(FD As String,FN As String)
		MP.Load(FD,FN)
		MP.SetVolume(1,1)
		MP.Play
	End Sub

#end if
#End Region B4a Code
